'use strict';

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _Rasterizer = require('../services/Rasterizer');

var _modules = require('./modules');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// pretty errors for the win
require('pretty-error').start();

/**
 * Get port from environment and store in Express.
 */

/**
 * Import Dependencies
 */
var port = normalizePort(process.env.PORT || '3000');
_app2.default.set('port', port);

/**
 * Create HTTP server.
 */

var server = _modules.http.createServer(_app2.default);

/**
 * Listen on provided port, on all network interfaces.
 */

new _Rasterizer.Rasterizer({
  host: 'localhost',
  port: port,
  debug: true
}).startService().then(function (r) {
  _app2.default.set('rasterizer', r);
  server.on('error', onError);
  server.on('listening', onListening);
  server.listen(port);
});

/**
 * Normalize a port into a number, string, or false.
 */

function normalizePort(val) {
  var _port = parseInt(val, 10);

  if (isNaN(_port)) {
    // named pipe
    return val;
  }

  if (_port >= 0) {
    // port number
    return _port;
  }

  return false;
}

/**
 * Event listener for HTTP server "error" event.
 */

function onError(error) {
  if (error.syscall !== 'listen') {
    throw error;
  }

  var bind = typeof port === 'string' ? 'Pipe ' + port : 'Port ' + port;

  // handle specific listen errors with friendly messages
  switch (error.code) {
    case 'EACCES':
      console.error(bind + ' requires elevated privileges');
      process.exit(1);
      break;
    case 'EADDRINUSE':
      console.error(bind + ' is already in use');
      process.exit(1);
      break;
    default:
      throw error;
  }
}

/**
 * Event listener for HTTP server "listening" event.
 */

function onListening() {
  var addr = server.address();
  var bind = typeof addr === 'string' ? 'pipe ' + addr : 'port ' + addr.port;
  console.log('Listening on ' + bind);
}