'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.api = undefined;

var _modules = require('./modules');

var apiRoute = _modules.express.Router();

apiRoute.get('/code/:id', function (req, res) {
  var data = require('../../data/' + req.params.id + '.png.meta.json');
  res.json(data);
});

apiRoute.get('/list', function (req, res, next) {

  _modules.fs.readdir(_modules.path.join(__dirname, '../../data'), function (err, files) {
    var data = [];

    if (err) {
      next(err);
      return;
    }

    files.forEach(function (file, i) {
      if (file.indexOf('json') > -1) {
        var fileData = require(_modules.path.join(__dirname, '../../data', file));
        data.push(fileData);
        if (i === files.length - 1) {
          res.json(data);
        }
      }
    });
  });
});

apiRoute.post('/add', function (req, res, next) {
  if (req.rasterizer) {
    var chance = new _modules.Chance();
    var hash = chance.hash();
    req.rasterizer.rasterizeCode(req.body.code, 'data/' + hash + '.png').then(function (file) {
      req.codepic = file;
      next();
    }).catch(function (err) {
      console.error(err);
    });
  } else {
    next();
  }
});

apiRoute.post('/add', function (req, res, next) {
  if (req.codepic) {
    res.json(req.codepic);
  } else {
    next();
  }
});

apiRoute.post('/', function (req, res, next) {
  try {
    var code = req.body.code;

    var parsed = _modules.hljs.highlightAuto(code);
    res.render('canvas', {
      title: 'codepic',
      description: 'your code',
      codez: parsed.value
    });
  } catch (err) {
    next(err);
  }
});

var api = exports.api = apiRoute;